<template>
  <div class="app-container">
    <div class="filter-container">
      <el-input v-model="query.title" :placeholder="$t('table.title')" style="width: 200px;" class="filter-item" @keyup.enter.native="handleFilter" />
      <el-button class="filter-item" type="primary" icon="el-icon-search" @click="handleFilter">
        {{ $t('table.search') }}
      </el-button>
      <el-button class="filter-item fa fa-plus" type="primary" @click="handleFilter">
        {{ $t('route.createTask') }}
      </el-button>
      <!--<el-button v-waves :loading="downloading" class="filter-item" type="primary" icon="el-icon-download" @click="handleDownload">-->
      <!--{{ $t('table.export') }}-->
      <!--</el-button>-->
    </div>
    <el-table v-loading="listLoading" :data="list" border fit highlight-current-row style="width: 100%">
      <el-table-column min-width="300px" align="center" :label="$t('row.title')">
        <template slot-scope="scope">
          <span>{{ scope.row.title }}</span>
        </template>
      </el-table-column>
      <el-table-column min-width="300px" align="center" :label="$t('row.explain')">
        <template slot-scope="scope">
          <span>{{ scope.row.explain }}</span>
        </template>
      </el-table-column>

      <el-table-column width="320px" align="center" :label="$t('row.createdBy')">
        <template slot-scope="scope">
          <span>{{ scope.row.user }}</span>
        </template>
      </el-table-column>

      <el-table-column align="center" :label="$t('row.operation')">
        <template slot-scope="scope">
          <span style="display: inline-block;width: 20px">
            <svg-icon v-if="scope.row.balance>0" icon-class="guide" class="pointer mr-1 ml-1" @click.native.prevent="handleTransfer(scope.row.publicAddress)" />
          </span>
          <span style="display: inline-block;width: 20px">
            <a class="fa fa-trash pointer mr-1 ml-1">&nbsp;</a>
          </span>
        </template>
      </el-table-column>
    </el-table>
    <pagination v-show="total>0" :total="total" :page.sync="query.page" :limit.sync="query.limit" @pagination="getList" />
  </div>
</template>

<script>
import Pagination from '@/components/Pagination'; // Secondary package based on el-pagination
import Task from '@/api/task';
const taskResource = new Task('tasks');
import 'vue-select/src/scss/vue-select.scss';

export default {
  name: 'TaskList',
  components: { Pagination },
  filters: {
    statusFilter(status) {
      const statusMap = {
        published: 'success',
        draft: 'info',
        deleted: 'danger',
      };
      return statusMap[status];
    },
  },
  data() {
    return {
      list: null,
      listTransfer: null,
      total: 0,
      newTransfer: {},
      newTransferCoin: {},
      listTransferQuery: {},
      listLoading: true,
      listTransferLoading: false,
      dialogFormVisible: false,
      dialogFormListVisible: false,
      transferToken: false,
      query: {
        page: 1,
        limit: 15,
        title: '',
        role: '',
      },
      options: [],
    };
  },
  created() {
    this.getList();
  },
  methods: {
    async getList() {
      this.listLoading = true;
      const { result } = await taskResource.list(this.query);
      this.list = result.rows;
      this.total = result.total;
      this.listLoading = false;
    },
    handleFilter() {
      this.query.page = 1;
      this.getList();
    },
    onSearch(search, loading) {
      fetch(
        '/api/searchUsers?q=' + search
      ).then(res => {
        res.json().then(json => (this.options = json.items));
        console.log(this.options);
        loading(false);
      });
    },
  },
};
</script>
